package tools.descartes.dql.core.engine.util;

import org.eclipse.core.filesystem.EFS;
import org.eclipse.core.filesystem.IFileStore;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.IDE;

public class EditorHelper {

	public static void openInEditor(String path) {
		IPath iPath = new Path(path);
		IWorkbench wb = PlatformUI.getWorkbench();
		IWorkbenchWindow win = wb.getActiveWorkbenchWindow();
		if (win == null) {
			win = wb.getWorkbenchWindows()[0]; // quick fix if get active window fails
		}

		if (win != null) {
			IWorkbenchPage page = win.getActivePage();
			if (page != null) {
				IFileStore fileStore = EFS.getLocalFileSystem().getStore(iPath);

				Display.getDefault().asyncExec(new Runnable() {
					public void run() {
						try {
							IDE.openEditorOnFileStore(page, fileStore);
						} catch (PartInitException pie) {
							System.err.println("Unable to open the Editor");
							System.err.println(pie.getStackTrace());
						} catch (SWTException e) {
							System.err.println(e.getStackTrace());
						}
					}
				});

			}
		}
	}
}
